Index: /palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- /palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4399)
+++ /palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4400)
@@ -356,32 +416,370 @@
  SUBROUTINE vm_check_parameters
 
-    USE control_parameters,                                                    &
-        ONLY:  message_string, virtual_measurement
- 
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  input_pids_static, input_pids_vm
-        
-    IMPLICIT NONE
-
-!
-!-- Virtual measurements require a setup file. 
-    IF ( virtual_measurement  .AND.  .NOT. input_pids_vm )  THEN
+    IF ( .NOT. virtual_measurement )  RETURN
+!
+!-- Virtual measurements require a setup file.
+    IF ( .NOT. input_pids_vm )  THEN
        message_string = 'If virtual measurements are taken, a setup input ' // &
                         'file for the site locations is mandatory.'
        CALL message( 'vm_check_parameters', 'PA0533', 1, 2, 0, 6, 0 )
-    ENDIF   
+    ENDIF
 !
 !-- In case virtual measurements are taken, a static input file is required.
 !-- This is because UTM coordinates for the PALM domain origin are required
-!-- for correct mapping of the measurements. 
+!-- for correct mapping of the measurements.
 !-- ToDo: Revise this later and remove this requirement.
-    IF ( virtual_measurement  .AND.  .NOT. input_pids_static )  THEN
+    IF ( .NOT. input_pids_static )  THEN
        message_string = 'If virtual measurements are taken, a static input ' //&
                         'file is mandatory.'
        CALL message( 'vm_check_parameters', 'PA0534', 1, 2, 0, 6, 0 )
     ENDIF
- 
+
+#if !defined( __netcdf4_parallel )
+!
+!-- In case of non-parallel NetCDF the virtual measurement output is not
+!-- working. This is only designed for parallel NetCDF.
+    message_string = 'If virtual measurements are taken, parallel ' //         &
+                     'NetCDF is required.'
+    CALL message( 'vm_check_parameters', 'PA0708', 1, 2, 0, 6, 0 )
+#endif
+!
+!-- Check if the given number of neighboring grid points do not exceeds the number
+!-- of ghost points.
+    IF ( off_pr > nbgp - 1  .OR.  off_ts > nbgp - 1  .OR.  off_tr > nbgp - 1 ) &
+    THEN
+       WRITE(message_string,*)                                                 &
+                        'If virtual measurements are taken, the number ' //    &
+                        'of surrounding grid points must not be larger ' //    &
+                        'than the number of ghost points - 1, which is: ',     &
+                        nbgp - 1
+       CALL message( 'vm_check_parameters', 'PA0705', 1, 2, 0, 6, 0 )
+    ENDIF
+!
+!-- Check if restart activation string is set. Virtual measurements may exceed
+!-- the maximum number of allowed timesteps in a NetCDF file. In order to handle
+!-- this, the module will trigger a programm abortion with writing the restart
+!-- data.
+    IF ( .NOT. write_binary )  THEN
+       message_string = 'virtual measurements require file activation ' //     &
+                        'string "restart"'
+       CALL message( 'check_parameters', 'PA0706', 1, 2, 0, 6, 0 )
+    ENDIF
+
  END SUBROUTINE vm_check_parameters
  
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Subroutine defines variable attributes according to UC2 standard. Note, later
+!> this list can be moved to the data-output module where it can be re-used also
+!> for other output.
+!------------------------------------------------------------------------------!
+  SUBROUTINE vm_set_attributes( output_variable )
+
+     TYPE( virt_var_atts ), INTENT(INOUT) ::  output_variable !< data structure with attributes that need to be set
+
+     output_variable%long_name     = 'none'
+     output_variable%standard_name = 'none'
+     output_variable%units         = 'none'
+     output_variable%coordinates   = 'lon lat E_UTM N_UTM x y z time station_name'
+     output_variable%grid_mapping  = 'crs'
+
+     SELECT CASE ( TRIM( output_variable%name ) )
+
+        CASE ( 'u' )
+           output_variable%long_name     = 'u wind component'
+           output_variable%units         = 'm s-1'
+
+        CASE ( 'ua' )
+           output_variable%long_name     = 'eastward wind'
+           output_variable%standard_name = 'eastward_wind'
+           output_variable%units         = 'm s-1'
+
+        CASE ( 'v' )
+           output_variable%long_name     = 'v wind component'
+           output_variable%units         = 'm s-1'
+
+        CASE ( 'va' )
+           output_variable%long_name     = 'northward wind'
+           output_variable%standard_name = 'northward_wind'
+           output_variable%units         = 'm s-1'
+
+        CASE ( 'w' )
+           output_variable%long_name     = 'w wind component'
+           output_variable%standard_name = 'upward_air_velocity'
+           output_variable%units         = 'm s-1'
+
+        CASE ( 'wspeed' )
+           output_variable%long_name     = 'wind speed'
+           output_variable%standard_name = 'wind_speed'
+           output_variable%units         = 'm s-1'
+
+        CASE ( 'wdir' )
+           output_variable%long_name     = 'wind from direction'
+           output_variable%standard_name = 'wind_from_direction'
+           output_variable%units         = 'degrees'
+
+        CASE ( 'theta' )
+           output_variable%long_name     = 'air potential temperature'
+           output_variable%standard_name = 'air_potential_temperature'
+           output_variable%units         = 'K'
+
+        CASE ( 'utheta' )
+           output_variable%long_name     = 'eastward kinematic sensible heat flux in air'
+           output_variable%units         = 'K m s-1'
+
+        CASE ( 'vtheta' )
+           output_variable%long_name     = 'northward kinematic sensible heat flux in air'
+           output_variable%units         = 'K m s-1'
+
+        CASE ( 'wtheta' )
+           output_variable%long_name     = 'upward kinematic sensible heat flux in air'
+           output_variable%units         = 'K m s-1'
+
+        CASE ( 'ta' )
+           output_variable%long_name     = 'air temperature'
+           output_variable%standard_name = 'air_temperature'
+           output_variable%units         = 'degree_C'
+
+        CASE ( 'tva' )
+           output_variable%long_name     = 'virtual acoustic temperature'
+           output_variable%units         = 'K'
+
+        CASE ( 'haa' )
+           output_variable%long_name     = 'absolute atmospheric humidity'
+           output_variable%units         = 'kg m-3'
+
+        CASE ( 'hus' )
+           output_variable%long_name     = 'specific humidity'
+           output_variable%standard_name = 'specific_humidity'
+           output_variable%units         = 'kg kg-1'
+
+        CASE ( 'hur' )
+           output_variable%long_name     = 'relative humidity'
+           output_variable%standard_name = 'relative_humidity'
+           output_variable%units         = '1'
+
+        CASE ( 'rlu' )
+           output_variable%long_name     = 'upwelling longwave flux in air'
+           output_variable%standard_name = 'upwelling_longwave_flux_in_air'
+           output_variable%units         = 'W m-2'
+
+        CASE ( 'rlus' )
+           output_variable%long_name     = 'surface upwelling longwave flux in air'
+           output_variable%standard_name = 'surface_upwelling_longwave_flux_in_air'
+           output_variable%units         = 'W m-2'
+
+        CASE ( 'rld' )
+           output_variable%long_name     = 'downwelling longwave flux in air'
+           output_variable%standard_name = 'downwelling_longwave_flux_in_air'
+           output_variable%units         = 'W m-2'
+
+        CASE ( 'rsddif' )
+           output_variable%long_name     = 'diffuse downwelling shortwave flux in air'
+           output_variable%standard_name = 'diffuse_downwelling_shortwave_flux_in_air'
+           output_variable%units         = 'W m-2'
+
+        CASE ( 'rsd' )
+           output_variable%long_name     = 'downwelling shortwave flux in air'
+           output_variable%standard_name = 'downwelling_shortwave_flux_in_air'
+           output_variable%units         = 'W m-2'
+
+        CASE ( 'rnds' )
+           output_variable%long_name     = 'surface net downward radiative flux'
+           output_variable%standard_name = 'surface_net_downward_radiative_flux'
+           output_variable%units         = 'W m-2'
+
+        CASE ( 'rsu' )
+           output_variable%long_name     = 'upwelling shortwave flux in air'
+           output_variable%standard_name = 'upwelling_shortwave_flux_in_air'
+           output_variable%units         = 'W m-2'
+
+        CASE ( 'rsus' )
+           output_variable%long_name     = 'surface upwelling shortwave flux in air'
+           output_variable%standard_name = 'surface_upwelling_shortwave_flux_in_air'
+           output_variable%units         = 'W m-2'
+
+        CASE ( 'rsds' )
+           output_variable%long_name     = 'surface downwelling shortwave flux in air'
+           output_variable%standard_name = 'surface_downwelling_shortwave_flux_in_air'
+           output_variable%units         = 'W m-2'
+
+        CASE ( 'hfss' )
+           output_variable%long_name     = 'surface upward sensible heat flux'
+           output_variable%standard_name = 'surface_upward_sensible_heat_flux'
+           output_variable%units         = 'W m-2'
+
+        CASE ( 'hfls' )
+           output_variable%long_name     = 'surface upward latent heat flux'
+           output_variable%standard_name = 'surface_upward_latent_heat_flux'
+           output_variable%units         = 'W m-2'
+
+        CASE ( 'ts' )
+           output_variable%long_name     = 'surface temperature'
+           output_variable%standard_name = 'surface_temperature'
+           output_variable%units         = 'K'
+
+        CASE ( 'thetas' )
+           output_variable%long_name     = 'surface layer temperature scale'
+           output_variable%units         = 'K'
+
+        CASE ( 'us' )
+           output_variable%long_name     = 'friction velocity'
+           output_variable%units         = 'm s-1'
+
+        CASE ( 'uw' )
+           output_variable%long_name     = 'upward eastward kinematic momentum flux in air'
+           output_variable%units         = 'm2 s-2'
+
+        CASE ( 'vw' )
+           output_variable%long_name     = 'upward northward kinematic momentum flux in air'
+           output_variable%units         = 'm2 s-2'
+
+        CASE ( 'uv' )
+           output_variable%long_name     = 'eastward northward kinematic momentum flux in air'
+           output_variable%units         = 'm2 s-2'
+
+        CASE ( 'plev' )
+           output_variable%long_name     = 'air pressure'
+           output_variable%standard_name = 'air_pressure'
+           output_variable%units         = 'Pa'
+
+        CASE ( 'm_soil' )
+           output_variable%long_name     = 'soil moisture volumetric'
+           output_variable%units         = 'm3 m-3'
+
+        CASE ( 't_soil' )
+           output_variable%long_name     = 'soil temperature'
+           output_variable%standard_name = 'soil_temperature'
+           output_variable%units         = 'degree_C'
+
+        CASE ( 'hfdg' )
+           output_variable%long_name     = 'downward heat flux at ground level in soil'
+           output_variable%standard_name = 'downward_heat_flux_at_ground_level_in_soil'
+           output_variable%units         = 'W m-2'
+
+        CASE ( 'hfds' )
+           output_variable%long_name     = 'downward heat flux in soil'
+           output_variable%standard_name = 'downward_heat_flux_in_soil'
+           output_variable%units         = 'W m-2'
+
+        CASE ( 'hfla' )
+           output_variable%long_name     = 'upward latent heat flux in air'
+           output_variable%standard_name = 'upward_latent_heat_flux_in_air'
+           output_variable%units         = 'W m-2'
+
+        CASE ( 'hfsa' )
+           output_variable%long_name     = 'upward latent heat flux in air'
+           output_variable%standard_name = 'upward_sensible_heat_flux_in_air'
+           output_variable%units         = 'W m-2'
+
+        CASE ( 'jno2' )
+           output_variable%long_name     = 'photolysis rate of nitrogen dioxide'
+           output_variable%standard_name = 'photolysis_rate_of_nitrogen_dioxide'
+           output_variable%units         = 's-1'
+
+        CASE ( 'lwcs' )
+           output_variable%long_name     = 'liquid water content of soil layer'
+           output_variable%standard_name = 'liquid_water_content_of_soil_layer'
+           output_variable%units         = 'kg m-2'
+
+        CASE ( 'lwp' )
+           output_variable%long_name     = 'liquid water path'
+           output_variable%standard_name = 'atmosphere_mass_content_of_cloud_liquid_water'
+           output_variable%units         = 'kg m-2'
+
+        CASE ( 'ps' )
+           output_variable%long_name     = 'surface air pressure'
+           output_variable%standard_name = 'surface_air_pressure'
+           output_variable%units         = 'hPa'
+
+        CASE ( 'pswrtg' )
+           output_variable%long_name     = 'platform speed wrt ground'
+           output_variable%standard_name = 'platform_speed_wrt_ground'
+           output_variable%units         = 'm s-1'
+
+        CASE ( 'pswrta' )
+           output_variable%long_name     = 'platform speed wrt air'
+           output_variable%standard_name = 'platform_speed_wrt_air'
+           output_variable%units         = 'm s-1'
+
+        CASE ( 'pwv' )
+           output_variable%long_name     = 'water vapor partial pressure in air'
+           output_variable%standard_name = 'water_vapor_partial_pressure_in_air'
+           output_variable%units         = 'hPa'
+
+        CASE ( 'ssdu' )
+           output_variable%long_name     = 'duration of sunshine'
+           output_variable%standard_name = 'duration_of_sunshine'
+           output_variable%units         = 's'
+
+        CASE ( 't_lw' )
+           output_variable%long_name     = 'land water temperature'
+           output_variable%units         = 'degree_C'
+
+        CASE ( 'tb' )
+           output_variable%long_name     = 'brightness temperature'
+           output_variable%standard_name = 'brightness_temperature'
+           output_variable%units         = 'K'
+
+        CASE ( 'uqv' )
+           output_variable%long_name     = 'eastward kinematic latent heat flux in air'
+           output_variable%units         = 'g kg-1 m s-1'
+
+        CASE ( 'vqv' )
+           output_variable%long_name     = 'northward kinematic latent heat flux in air'
+           output_variable%units         = 'g kg-1 m s-1'
+
+        CASE ( 'wqv' )
+           output_variable%long_name     = 'upward kinematic latent heat flux in air'
+           output_variable%units         = 'g kg-1 m s-1'
+
+        CASE ( 'zcb' )
+           output_variable%long_name     = 'cloud base altitude'
+           output_variable%standard_name = 'cloud_base_altitude'
+           output_variable%units         = 'm'
+
+        CASE ( 'zmla' )
+           output_variable%long_name     = 'atmosphere boundary layer thickness'
+           output_variable%standard_name = 'atmosphere_boundary_layer_thickness'
+           output_variable%units         = 'm'
+
+        CASE ( 'mcpm1' )
+           output_variable%long_name     = 'mass concentration of pm1 ambient aerosol particles in air'
+           output_variable%standard_name = 'mass_concentration_of_pm1_ambient_aerosol_particles_in_air'
+           output_variable%units         = 'kg m-3'
+
+        CASE ( 'mcpm10' )
+           output_variable%long_name     = 'mass concentration of pm10 ambient aerosol particles in air'
+           output_variable%standard_name = 'mass_concentration_of_pm10_ambient_aerosol_particles_in_air'
+           output_variable%units         = 'kg m-3'
+
+        CASE ( 'mcpm2p5' )
+           output_variable%long_name     = 'mass concentration of pm2p5 ambient aerosol particles in air'
+           output_variable%standard_name = 'mass_concentration_of_pm2p5_ambient_aerosol_particles_in_air'
+           output_variable%units         = 'kg m-3'
+
+        CASE ( 'mfno', 'mcno'  )
+           output_variable%long_name     = 'mole fraction of nitrogen monoxide in air'
+           output_variable%standard_name = 'mole_fraction_of_nitrogen_monoxide_in_air'
+           output_variable%units         = 'ppm' !'mol mol-1'
+
+        CASE ( 'mfno2', 'mcno2'  )
+           output_variable%long_name     = 'mole fraction of nitrogen dioxide in air'
+           output_variable%standard_name = 'mole_fraction_of_nitrogen_dioxide_in_air'
+           output_variable%units         = 'ppm' !'mol mol-1'
+
+        CASE ( 'tro3'  )
+           output_variable%long_name     = 'mole fraction of ozone in air'
+           output_variable%standard_name = 'mole_fraction_of_ozone_in_air'
+           output_variable%units         = 'ppm' !'mol mol-1'
+
+        CASE DEFAULT
+
+     END SELECT
+
+  END SUBROUTINE vm_set_attributes
+
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -390,13 +788,15 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE vm_parin
- 
+
     CHARACTER (LEN=80) ::  line   !< dummy string that contains the current line of the parameter file
- 
-    NAMELIST /virtual_measurement_parameters/  dt_virtual_measurement,                             &
-                                               use_virtual_measurement,                            &
+
+    NAMELIST /virtual_measurement_parameters/  dt_virtual_measurement,         &
+                                               off_ts,                         &
+                                               off_pr,                         &
+                                               off_tr,                         &
+                                               use_virtual_measurement,        &
                                                vm_time_start
 
     line = ' '
-
 !
 !-- Try to find stg package
@@ -415,5 +815,5 @@
 !-- Set flag that indicates that the virtual measurement module is switched on
     IF ( use_virtual_measurement )  virtual_measurement = .TRUE.
-    
+
     GOTO 20
 
@@ -423,5 +823,5 @@
 
  20 CONTINUE
- 
+
  END SUBROUTINE vm_parin
 
@@ -430,5 +830,5 @@
 ! Description:
 ! ------------
-!> Initialize virtual measurements: read coordiante arrays and measured 
+!> Initialize virtual measurements: read coordiante arrays and measured
 !> variables, set indicies indicating the measurement points, read further
 !> attributes, etc..
@@ -436,27 +836,9 @@
  SUBROUTINE vm_init
 
-    USE arrays_3d,                                                             &
-        ONLY:  zu, zw
-        
-    USE grid_variables,                                                        &
-        ONLY:  ddx, ddy, dx, dy
-        
-    USE indices,                                                               &
-        ONLY:  nxl, nxr, nyn, nys
- 
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  get_dimension_length,                                           &
-               init_model,                                                     &
-               input_file_vm,                                                  &
-               netcdf_data_input_att,                                          &
-               netcdf_data_input_var
-        
-    IMPLICIT NONE
-    
-    CHARACTER(LEN=5)    ::  dum                !< dummy string indicate station id
-    CHARACTER(LEN=10), DIMENSION(50) ::  measured_variables_file = '' !< array with all measured variables read from NetCDF
-    CHARACTER(LEN=10), DIMENSION(50) ::  measured_variables      = '' !< dummy array with all measured variables that are allowed   
-    
-    INTEGER(iwp) ::  dim_ntime !< dimension size of time coordinate 
+    CHARACTER(LEN=5)                  ::  dum                          !< dummy string indicating station id
+    CHARACTER(LEN=100), DIMENSION(50) ::  measured_variables_file = '' !< array with all measured variables read from NetCDF
+    CHARACTER(LEN=100), DIMENSION(50) ::  measured_variables      = '' !< dummy array with all measured variables that are allowed
+
+    INTEGER(iwp) ::  dim_ntime !< dimension size of time coordinate
     INTEGER(iwp) ::  i         !< grid index of virtual observation point in x-direction
     INTEGER(iwp) ::  is        !< grid index of real observation point of the respective station in x-direction
@@ -471,52 +853,60 @@
     INTEGER(iwp) ::  len_char  !< character length of single measured variables without Null character
     INTEGER(iwp) ::  ll        !< running index over all measured variables in file
-    INTEGER(iwp) ::  lll       !< running index over all allowed variables
+    INTEGER(iwp) ::  m         !< running index for surface elements
     INTEGER(iwp) ::  n         !< running index over trajectory coordinates
+    INTEGER(iwp) ::  nofill    !< dummy for nofill return value (not used)
     INTEGER(iwp) ::  ns        !< counter variable for number of observation points on subdomain
+    INTEGER(iwp) ::  off       !< number of surrounding grid points to be sampled
     INTEGER(iwp) ::  t         !< running index over number of trajectories
-    INTEGER(iwp) ::  m
-    
-    INTEGER(KIND=1)::  soil_dum
-    
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ns_all !< dummy array used to sum-up the number of observation coordinates
-    
+
+    INTEGER(KIND=1)                             ::  soil_dum !< dummy variable to input a soil flag
+
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE     ::  ns_all !< dummy array used to sum-up the number of observation coordinates
+
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE   ::  ns_atmos !< number of observation points for each station on each mpi rank
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE   ::  ns_soil  !< number of observation points for each station on each mpi rank
+
     INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  meas_flag !< mask array indicating measurement positions
-    
-!    LOGICAL ::  chem_include !< flag indicating that chemical species is considered in modelled mechanism
-    LOGICAL ::  on_pe        !< flag indicating that the respective measurement coordinate is on subdomain
-    
-    REAL(wp)     ::  fill_eutm !< _FillValue for coordinate array E_UTM
-    REAL(wp)     ::  fill_nutm !< _FillValue for coordinate array N_UTM
-    REAL(wp)     ::  fill_zag  !< _FillValue for height coordinate
-    
+
+    LOGICAL  ::  on_pe        !< flag indicating that the respective measurement coordinate is on subdomain
+
+    REAL(wp) ::  fill_eutm !< _FillValue for coordinate array E_UTM
+    REAL(wp) ::  fill_nutm !< _FillValue for coordinate array N_UTM
+    REAL(wp) ::  fill_zar  !< _FillValue for height coordinate
+
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  e_utm     !< easting UTM coordinate, temporary variable
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  n_utm     !< northing UTM coordinate, temporary variable
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  e_utm_tmp !< EUTM coordinate before rotation
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  n_utm_tmp !< NUTM coordinate before rotation
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  z_ag      !< height coordinate relative to origin_z, temporary variable
-!
-!-- Obtain number of sites. Also, pass the 'open' string, in order to initially
-!-- open the measurement driver. 
-    CALL netcdf_data_input_att( vmea_general%nvm, char_numstations,            &
-                                vmea_general%id_vm, input_file_vm,             &
-                                global_attribute, 'open', '' )
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  station_h !< station height above reference
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zar       !< observation height above reference
+#if defined( __netcdf )
+!
+!-- Open the input file.
+    CALL open_read_file( input_file_vm, pids_id )
+!
+!-- Obtain number of sites.
+    CALL get_attribute( pids_id,                                               &
+                        char_numstations,                                      &
+                        vmea_general%nvm,                                      &
+                        global_attribute )
 !
 !-- Allocate data structure which encompass all required information, such as
-!-- grid points indicies, absolute UTM coordinates, the measured quantities, 
+!-- grid points indicies, absolute UTM coordinates, the measured quantities,
 !-- etc. .
     ALLOCATE( vmea(1:vmea_general%nvm) )
 !
 !-- Allocate flag array. This dummy array is used to identify grid points
-!-- where virtual measurements should be taken. Please note, at least one 
-!-- ghost point is required, in order to include also the surrounding 
-!-- grid points of the original coordinate.  
-    ALLOCATE( meas_flag(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+!-- where virtual measurements should be taken. Please note, in order to 
+!-- include also the surrounding grid points of the original coordinate
+!-- ghost points are required.
+    ALLOCATE( meas_flag(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
     meas_flag = 0
 !
-!-- Loop over all sites.
+!-- Loop over all sites in the setup file.
     DO  l = 1, vmea_general%nvm
 !
 !--    Determine suffix which contains the ID, ordered according to the number
-!--    of measurements. 
+!--    of measurements.
        IF( l < 10 )  THEN
           WRITE( dum, '(I1)')  l
@@ -531,35 +921,35 @@
        ENDIF
 !
-!--    Read site coordinates (UTM).
-       CALL netcdf_data_input_att( vmea(l)%origin_x_obs, char_origx //         &
-                                   TRIM( dum ), vmea_general%id_vm, '',        &
-                                   global_attribute, '', '' )
-       CALL netcdf_data_input_att( vmea(l)%origin_y_obs, char_origy //         &
-                                   TRIM( dum ), vmea_general%id_vm, '',        &
-                                   global_attribute, '', '' )
-!
-!--    Read site name                  
-       CALL netcdf_data_input_att( vmea(l)%site, char_site // TRIM( dum ),     &
-                                   vmea_general%id_vm, '', global_attribute,   &
-                                   '', '' )
+!--    Read the origin site coordinates (UTM).
+       CALL get_attribute( pids_id,                                            &
+                           char_origx // TRIM( dum ),                          &
+                           vmea(l)%origin_x_obs,                               &
+                           global_attribute )
+       CALL get_attribute( pids_id,                                            &
+                           char_origy // TRIM( dum ),                          &
+                           vmea(l)%origin_y_obs,                               &
+                           global_attribute )
+!
+!--    Read site name.
+       CALL get_attribute( pids_id,                                            &
+                           char_site // TRIM( dum ),                           &
+                           vmea(l)%site,                                       &
+                           global_attribute )
+!
+!--    Read a flag which indicates that also soil quantities are take at the
+!--    respective site (is part of the virtual measurement driver).
+       CALL get_attribute( pids_id,                                            &
+                           char_soil // TRIM( dum ),                           &
+                           soil_dum,                                           &
+                           global_attribute )
+!
+!--    Set flag indicating soil-sampling.
+       IF ( soil_dum == 1 )  vmea(l)%soil_sampling = .TRUE.
 !
 !--    Read type of the measurement (trajectory, profile, timeseries).
-       CALL netcdf_data_input_att( vmea(l)%feature_type, char_feature //       &
-                                   TRIM( dum ), vmea_general%id_vm, '',        &
-                                   global_attribute, '', '' )
-!
-!--    Read the name of the original file where observational data is stored. 
-       CALL netcdf_data_input_att( vmea(l)%filename_original, char_filename // &
-                                   TRIM( dum ), vmea_general%id_vm, '',        &
-                                   global_attribute, '', '' )
-!
-!--    Read a flag which indicates that also soil quantities are take at the 
-!--    respective site (is part of the virtual measurement driver).  
-       CALL netcdf_data_input_att( soil_dum, char_soil // TRIM( dum ),         &
-                                   vmea_general%id_vm, '', global_attribute,   &
-                                   '', '' )
-!
-!--    Set flag for soil-sampling.
-       IF ( soil_dum == 1 )  vmea(l)%soil_sampling = .TRUE.
+       CALL get_attribute( pids_id,                                            &
+                           char_feature // TRIM( dum ),                        &
+                           vmea(l)%feature_type,                               &
+                           global_attribute )
 !
 !---   Set logicals depending on the type of the measurement
@@ -571,24 +961,24 @@
           vmea(l)%trajectory        = .TRUE.
 !
-!--   Give error message in case the type matches non of the pre-defined types.
+!--    Give error message in case the type matches non of the pre-defined types.
        ELSE
           message_string = 'Attribue featureType = ' //                        &
                            TRIM( vmea(l)%feature_type ) //                     &
-                           ' is not allowed.' 
+                           ' is not allowed.'
           CALL message( 'vm_init', 'PA0535', 1, 2, 0, 6, 0 )
        ENDIF
 !
-!--    Read string with all measured variables at this site
+!--    Read string with all measured variables at this site.
        measured_variables_file = ''
-       CALL netcdf_data_input_var( measured_variables_file,                    &
-                                   char_mv // TRIM( dum ), vmea_general%id_vm )
-!
-!--    Count the number of measured variables. Only count variables that match
-!--    with the allowed variables. 
+       CALL get_variable( pids_id,                                             &
+                          char_mv // TRIM( dum ),                              &
+                          measured_variables_file )
+!
+!--    Count the number of measured variables.
 !--    Please note, for some NetCDF interal reasons characters end with a NULL,
 !--    i.e. also empty characters contain a NULL. Therefore, check the strings
-!--    for a NULL to get the correct character length in order to compare 
-!--    them with the list of allowed variables. 
-       vmea(l)%nmeas  = 0
+!--    for a NULL to get the correct character length in order to compare
+!--    them with the list of allowed variables.
+       vmea(l)%nmeas  = 1
        DO ll = 1, SIZE( measured_variables_file )
           IF ( measured_variables_file(ll)(1:1) /= CHAR(0)  .AND.              &
